(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('prop-types')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'prop-types'], factory) :
  (factory((global.index = {}),global.React,global.PropTypes));
}(this, (function (exports,React,PropTypes) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;
  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    subClass.__proto__ = superClass;
  }

  var _isPromise_2_1_0_isPromise = isPromise;

  function isPromise(obj) {
    return !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function';
  }

  var some = function some(arr, pred) {
    arr = arr || [];

    for (var i = 0; i < arr.length; ++i) {
      if (pred && pred(arr[i])) {
        return true;
      }
    }

    return false;
  };
  var toPairs = function toPairs(obj) {
    return obj ? Object.keys(obj).map(function (k) {
      return [k, obj[k]];
    }) : [];
  };
  var fromPairs = function fromPairs(arr) {
    var ret = {};
    (arr || []).forEach(function (_ref) {
      var k = _ref[0],
          v = _ref[1];
      return ret[k] = v;
    });
    return ret;
  };
  var isFunction = function isFunction(func) {
    return typeof func === 'function';
  };

  var DefaultLoadingComponent = function DefaultLoadingComponent() {
    return null;
  };

  var DefaultErrorComponent = function DefaultErrorComponent() {
    return null;
  };

  var AsyncComponent =
  /*#__PURE__*/
  function (_Component) {
    _inheritsLoose(AsyncComponent, _Component);

    function AsyncComponent() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _Component.call.apply(_Component, [this].concat(args)) || this;
      _this.errorComponent = null;
      _this.state = {
        error: null,
        loading: true,
        resolvedProps: {}
      };
      return _this;
    }

    var _proto = AsyncComponent.prototype;

    _proto.componentDidMount = function componentDidMount() {
      this.mounted = true;
      this.load();
    };

    _proto.componentWillUpdate = function componentWillUpdate() {
      this.mounted = false;
    };

    _proto.load = function load() {
      var _this2 = this;

      var pairs = toPairs(this.props.asyncProps || {}).filter(function (entry) {
        return entry[1];
      });

      if (some(pairs, function (entry) {
        return !isFunction(entry[1]);
      })) {
        this.setState({
          error: new Error('The prop of asyncProps must be a function.'),
          loading: false
        });
        return;
      }

      var batch = this.props.batch;
      var promises = pairs.map(function (_ref) {
        var k = _ref[0],
            v = _ref[1];
        return new Promise(function (resolve) {
          return resolve([k, v()]);
        }).then(function (_ref2) {
          var k = _ref2[0],
              p = _ref2[1];

          if (_isPromise_2_1_0_isPromise(p)) {
            return p.then(function (res) {
              if (!batch) {
                if (_this2.mounted) {
                  _this2.setState(AsyncComponent.updateResolvedProps({
                    k: res
                  }));
                } else {
                  _this2.state.resolvedProps[k] = res;
                }
              }

              return [k, res];
            });
          }

          return [k, p];
        });
      });
      Promise.all(promises).then(function (pairs) {
        if (_this2.mounted) {
          _this2.setState({
            resolvedProps: fromPairs(pairs),
            error: null
          });
        } else {
          _this2.state.resolvedProps = fromPairs(pairs);
          _this2.state.error = null;
        }
      }).catch(function (e) {
        if (_this2.mounted) {
          _this2.setState({
            error: e
          });
        } else {
          _this2.state.error = e;
        }
      }).finally(function () {
        if (_this2.mounted) {
          _this2.setState({
            loading: false
          });
        } else {
          _this2.state.loading = false;
        }
      });
    };

    _proto.render = function render() {
      var _props = this.props,
          ErrorComponent = _props.errorComponent,
          LoadingComponent = _props.loadingComponent,
          Comp = _props.component,
          children = _props.children;
      var _state = this.state,
          error = _state.error,
          loading = _state.loading,
          resolvedProps = _state.resolvedProps;

      if (loading) {
        return React__default.createElement(LoadingComponent, _extends({}, this.props, resolvedProps));
      }

      if (error) {
        return React__default.createElement(ErrorComponent, _extends({}, this.props, resolvedProps, {
          error: error
        }));
      }

      if (Comp) {
        return React__default.createElement(Comp, _extends({}, this.props, resolvedProps));
      } // noinspection JSUnresolvedFunction JSCheckFunctionSignatures


      var newChildren = React__default.Children.map(children, function (child) {
        return React__default.cloneElement(child, resolvedProps);
      });

      if (newChildren.length === 1) {
        return newChildren[0];
      } else if (newChildren.length > 1) {
        return React__default.createElement("div", null, newChildren);
      }

      return null;
    };

    return AsyncComponent;
  }(React.Component);

  AsyncComponent.updateResolvedProps = function (resolvedProps) {
    return function (preState) {
      return {
        resolvedProps: _objectSpread({}, preState.resolvedProps, resolvedProps)
      };
    };
  };

  var bool = PropTypes.bool,
      object = PropTypes.object,
      func = PropTypes.func,
      oneOfType = PropTypes.oneOfType,
      arrayOf = PropTypes.arrayOf,
      element = PropTypes.element;
  AsyncComponent.propTypes = {
    batch: bool,
    // eslint-disable-next-line react/forbid-prop-types
    asyncProps: object.isRequired,
    component: func,
    children: oneOfType([element, arrayOf(element)]),
    errorComponent: func,
    loadingComponent: func
  };
  AsyncComponent.defaultProps = {
    batch: false,
    component: null,
    children: null,
    errorComponent: DefaultErrorComponent,
    loadingComponent: DefaultLoadingComponent
  };

  exports.AsyncComponent = AsyncComponent;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.js.map
